<?php

/**
 * Fpacalculofolha
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     SetForms Team <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage |$
 */
class Fpacalculofolha extends DaoFpaCalculofolha
{


    /**
     * Retorna lista de Objetos de Calculo de Folha .
     *
     * @param integer    $nr_org             Numero da Organizacao de Trabalho.
     * @param integer    $nr_tipo_movimento  Numero do Tipo do Movimento.
     * @param integer    $nrTpModalidadeCalc Numero do tipo de modalidade de calculo.
     * @param integer    $nrOcorrenciaCalc   Numero de ocorrencia de calculo.
     * @param TkDateTime $dt_inicial         Data Inicial.
     * @param TkDateTime $dt_final           Data Final.
     *
     * @return array FpacalculofolhaEntity
     *
     * @author alessandrobartels -
     *         alessandrobartels - 20/12/2011 - adicionado parametros de tipo modalidade e ocorrencia de calculo.
     */
    public static function retornaCalculoFolha($nr_org, $nr_tipo_movimento, $nrTpModalidadeCalc, $nrOcorrenciaCalc,
                                               $dt_inicial,$dt_final){

        $param = array($nr_org,
                        $nr_tipo_movimento,
                        $nrTpModalidadeCalc,
                        (int) $nrOcorrenciaCalc,
                        $dt_inicial,
                        $dt_final);

        //tk_backtrace();
        $resultado = self::getObjectsByWhere(
            'NRORG = ?
             AND NRTIPOMOVIMENT = ?
             AND NRTPMODALIDCAL = ?
             AND NROCORRECAL = ?
             AND (DTOCORRENCIA BETWEEN ? AND ?)',$param

        );
        return $resultado;
    }


    /**
     * Retorna lista de instancias de FpacalculofolhaEntity sem filtrar ocorrencia.
     *
     * @param integer    $nrOrg             Numero da Organizacao de Trabalho.
     * @param integer    $nrTipoMovimento  Numero do Tipo do Movimento.
     * @param integer    $nrTpModalidadeCalc Numero do tipo de modalidade de calculo.
     * @param TkDateTime $dtInicial         Data Inicial.
     * @param TkDateTime $dtFinal           Data Final.
     *
     * @return array FpacalculofolhaEntity
     *
     * @author alessandrobartels - 13/04/2012
     */
     public static function retornaCalculoFolhaTodasOcorrencias(
        $nrOrg, $nrTipoMovimento, $nrTpModalidadeCalc, TkDateTime $dtInicial, TkDateTime $dtFinal
    ){

        $resultado = self::getObjectsByWhere(
            'NRORG = ?
             AND NRTIPOMOVIMENT = ?
             AND NRTPMODALIDCAL = ?
             AND (DTOCORRENCIA BETWEEN ? AND ?)
             AND NROCORRECAL > 0',
            array(
             $nrOrg, $nrTipoMovimento, $nrTpModalidadeCalc, $dtInicial, $dtFinal,
            ),
            'DTOCORRENCIA'
        );
        return $resultado;
    }


   /* public static function retornaCalculoFolhaPorNumro($nrOrg, $nrCalculoFolha){
        $resultado = self::getObjectsByWhere(
            'NRORG = ?
             AND NRCALCULOFOLHA = ?',
            array(
             $nrOrg, $nrCalculoFolha,
            )
        );
        return $resultado;
    }*/
    
}