<?php
/**
 * Created by JetBrains PhpStorm.
 * User: alessandrobartel
 * Date: 15/02/12
 * Time: 10:49
 * To change this template use File | Settings | File Templates.
 */

/**
* Logic do login da folha de pagamento.
*
* @package Facade
*
* @author  alessandrobartels - 15/02/2012
*/
class FpaLoginLogic {

    private $_nrOrg;
    private $_cdOperador;
    private $_tipoOperador;
    private $_nrOrgPadrao;
    private $_nrOrgTrab;
    private $_nrEstrutTrab;
    private $_tpEstrutLegal;
    private $_tpEstrutGerencial;
    private $_mesCompetencia;
    private $_ultimoDiaMes;
    private $_modCalculo;
    private $_modSalario;
    private $_ocorrenciaCalculo;


    /**
    * Construtor.
    *
    * @param array $parametros Array de parametros.
    *
    * @autor alessandrobartels - 15/02/2012
    */
    public function __construct(\Geral\Logic\Login\LoginEstrutura $login){

        ini_set('session.gc_maxlifetime','');

        $this->_nrOrg      = $login->getOrganizacao()->getNrorg();
        $this->_cdOperador = $login->getOperador()->getCdoperador();
        \FPA::defineVariaveisAmbiente($this->_nrOrg, $this->_cdOperador);
    }

    public static function getCompetencia() {
        if(tk_get_env_var('COMPETENCIAORG')!==null){
            return tk_get_env_var('DTCOMPETENCIA');
        }
        return tk_get_env_var('COMPETENCIAORG');
    }


    /**
    * Atribui os valores das variaveis de ambiente.
    *
    * @return void
    *
    * @author alessandrobartels - 15/02/2012
    *         alessandrobartels - 26/03/2012 - inclusao tipo operador.
    *@deprecated
    */
//    public function loginFolha(){
//        $parametro = new Parametros($this->_nrOrg, $this->_cdOperador);
//
//        $this->_nrOrgPadrao = $parametro->getNrOrgPadrao();
//        $this->_nrOrgTrab = $parametro->getNrOrgTrabalho();
//        $this->_nrEstrutTrab = $parametro->getNrEstrutTrab();
//        $this->_tpEstrutLegal = $parametro->getTipoEstruturaLegal();
//        $this->_tpEstrutGerencial = $parametro->getTipoEstruturaGerencial();
//        $this->_mesCompetencia = $parametro->getMesCompetencia();
//        $this->_modCalculo = $parametro->getDescricaoTipoModalidadeCalculo();
//        $this->_modSalario = $parametro->getDescricaoTipoModalidadeSalario();
//        $this->_ocorrenciaCalculo = $parametro->getNrOcorrenciaCalculo();
//
//        FPA::atribuiVariaveisAmbiente(
//            $this->_nrOrgTrab, $this->_nrOrgPadrao, $this->_mesCompetencia, $this->_modCalculo, $this->_modSalario,
//            $this->_ocorrenciaCalculo, $this->_nrEstrutTrab, $this->_tpEstrutLegal, $this->_tpEstrutGerencial
//        );
//
//       //  $this->_tipoOperador = $parametro->getTipoOperador();
//    }

    /**
     * Retorna o numero da organizacao padrao.
     *
     * @return integer
     *
     * @author alessandrobartels - 15/02/2012
     */
    public function getNrOrgPadrao(){
        return $this->_nrOrgPadrao;
    }


    /**
     * Retorna o numero da organizacao de trabalho do operador logado.
     *
     * @return integer
     *
     * @author alessandrobartels - 15/02/2012
     */
    public function getNrOrgTrab(){
        $nrOrgTrab = $this->_nrOrgTrab;
        if (empty($nrOrgTrab) !== true) {
            return $this->_nrOrgTrab;
        } else {
            tk_warning('Org. de trabalho nao parametrizado em Parametros do Operador.');
        }
    }


    /**
     * Retorna o numero da Estrutura de trabalho.
     *
     * @return integer
     *
     * @author alessandrobartels - 27/03/2012
     */
    public function getNrEstrutTrab(){
        return $this->_nrEstrutTrab;
    }




    /**
    * Retorna a data de competencia do operador logado.
    *
    * @return string
    *
    * @author alessandrobartels - 15/02/2012
    */
    public function getMesCompetencia(){
        return $this->_mesCompetencia->__toString(TkDateTime::FORMAT_DATE);
    }


    /**
    * Retorna o tipo de modalidade de calculo.
    *
    * @return string
    *
    * @author alessandrobartels - 07/03/2012
    */
    public function getModalidadeCalculo(){
        return $this->_modCalculo;
    }


    /**
    * Retorna o tipo de modalidade de salario.
    *
    * @return string
    *
    * @author alessandrobartels - 07/03/2012
    */
    public function getModalidadeSalario(){
        return $this->_modSalario;
    }


    /**
    * Retorna a ocorrencia de calculo.
    *
    * @return string
    *
    * @author alessandrobartels - 07/03/2012
    */
    public function getOcorrenciaCalculo(){
        return $this->_ocorrenciaCalculo;
    }


   /**
    * Retorna o tipo de operador.
    *
    * @return string
    *
    * @author alessandrobartels - 26/03/2012
    */
    public function getTipoOperador(){
        return $this->_tipoOperador;
    }


   /**
    * Retorna o tipo de estrutura legal.
    *
    * @return string
    *
    * @author alessandrobartels - 30/03/2012
    */
    public function getTipoEstruturaLegal(){
        return $this->_tpEstrutLegal;
    }


   /**
    * Retorna o tipo de estrutura gerencial.
    *
    * @return string
    *
    * @author alessandrobartels - 30/03/2012
    */
    public function getTipoEstruturaGerencial(){
        return $this->_tpEstrutGerencial;
    }

}
